part of xpx_chain_sdk.buffer;

Schema transferTransactionSchema() {
  final List<SchemaAttribute> schemaDefinition = [
    _newScalarAttribute('size', _intSize),
    _newArrayAttribute('signature', _byteSize),
    _newArrayAttribute('signer', _byteSize),
    _newScalarAttribute('version', _shortSize),
    _newScalarAttribute('type', _shortSize),
    _newArrayAttribute('fee', _intSize),
    _newArrayAttribute('deadline', _intSize),
    _newArrayAttribute('recipient', _byteSize),
    _newScalarAttribute('messageSize', _shortSize),
    _newScalarAttribute('numMosaics', _byteSize),
    _newTableAttribute(
        'message',
        Schema([
          _newScalarAttribute('type', _byteSize),
          _newArrayAttribute('payload', _byteSize)
        ]).schemaDefinition),
    _newTableArrayAttribute(
        'mosaics',
        Schema([
          _newArrayAttribute('id', _intSize),
          _newArrayAttribute('amount', _intSize),
        ]).schemaDefinition)
  ];
  return Schema(schemaDefinition);
}
